#include <windows.h>
//#include <stdarg.h>
#include <gl\gl.h>
#include <gl\glu.h>
#include <gl\glaux.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <math.h>

HDC			hDC=NULL;		// Private GDI Device Context
HGLRC		hRC=NULL;		// Permanent Rendering Context
HWND		hWnd=NULL;		// Holds Our Window Handle
HINSTANCE	hInstance;		// Holds The Instance Of The Application

bool	keys[256];			// Array Used For The Keyboard Routine
bool	active=true;		// true si la fentre est active
bool	fullscreen=true;	// true si le mode plein cran est activ

int frame = 0;
clock_t timer;
float fps;

LRESULT	CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);	// Declaration For WndProc

int mode = 0; //=0 prsentation ; 2 jeu; 3 fin de partie

float view_x, view_y;

int width = 800, height = 600;
int timerota=4000;
int mouv_rx, mouv_ry, mouv_rz;
int FCselect[2], levelselect;
bool animencour, CclrReplace, hasFCselect=true;
clock_t rtimestart;
clock_t timegame;
char tempsdejeu[50];

int dimrubixcubes = 3;
int Cmax = dimrubixcubes-1;
int allCclr[10][10][10][6];
int alloldCclr[10][10][10][6];
int Cclr[6];
int RCclrCompteur[6]; 
int RCclrFace[6];
long double rtactu;
bool mustfinishmouv = true;

clock_t fpsclock;
clock_t chronostart;

GLuint wintitle, winmessage, bigtitle, fonttime, fontfps; //dclaration des listes polices
#include "font.h"

#include "fctcubeinit.h"
#include "drawing.h"

int random (int start, int stop){
	return (stop+1-start) * rand()/RAND_MAX + start;
}

void moovingview (){			//permet de faire tourner le cube dans le mode menu
	glRotated(view_x, 0, 1, 0);
	glRotated(view_y, 1, 0, 0);
}

void calculCclr(int i, int j, int k){							//calcul les couleurs du cube suivant les rotation ou non	
	if(animencour){												//si une animation est en cour
		coloraffect(Cclr, allCclr[i][j][k]);					//affecte les ancienne couleur au nouvelle (pas dec ouleur chang)
	}else if(mouv_rx!=0 && (levelselect==0 || levelselect==i+1)) {	//rotation dfinie suivant l'axe X
		if(mouv_rx>0){											//vers le bas => flche haut
			Cclr[3] = alloldCclr[i][k][Cmax-j][4];
			Cclr[2] = alloldCclr[i][k][Cmax-j][5];
			Cclr[5] = alloldCclr[i][k][Cmax-j][3];
			Cclr[4] = alloldCclr[i][k][Cmax-j][2];
			Cclr[0] = alloldCclr[i][k][Cmax-j][0];
			Cclr[1] = alloldCclr[i][k][Cmax-j][1];
		}else if(mouv_rx<0){									// vers le haut => flche bas
			Cclr[3] = alloldCclr[i][Cmax-k][j][5];
			Cclr[2] = alloldCclr[i][Cmax-k][j][4];
			Cclr[5] = alloldCclr[i][Cmax-k][j][2];
			Cclr[4] = alloldCclr[i][Cmax-k][j][3];
			Cclr[0] = alloldCclr[i][Cmax-k][j][0];
			Cclr[1] = alloldCclr[i][Cmax-k][j][1];
		}
		coloraffect(allCclr[i][j][k], Cclr);					//affecte les nouvelle couleur au tableau de couleur principal
	}else if(mouv_ry!=0 && (levelselect==0 || levelselect==j+1)) {	//rotation dfinie suivant l'axe Y
		if(mouv_ry<0){											//vers la gauche => flche droite
			Cclr[3] = alloldCclr[k][j][Cmax-i][3];
			Cclr[2] = alloldCclr[k][j][Cmax-i][2];
			Cclr[5] = alloldCclr[k][j][Cmax-i][1];
			Cclr[4] = alloldCclr[k][j][Cmax-i][0];
			Cclr[0] = alloldCclr[k][j][Cmax-i][5];
			Cclr[1] = alloldCclr[k][j][Cmax-i][4];
		}else if(mouv_ry>0){									// vers la droite => flche gauche
			Cclr[3] = alloldCclr[Cmax-k][j][i][3];
			Cclr[2] = alloldCclr[Cmax-k][j][i][2];
			Cclr[5] = alloldCclr[Cmax-k][j][i][0];
			Cclr[4] = alloldCclr[Cmax-k][j][i][1];
			Cclr[0] = alloldCclr[Cmax-k][j][i][4];
			Cclr[1] = alloldCclr[Cmax-k][j][i][5];
		}
		coloraffect(allCclr[i][j][k], Cclr);					//affecte les nouvelle couleur au tableau de couleur principal
	}else{														// si aucune rotation
		coloraffect(Cclr, allCclr[i][j][k]);					//affecte les ancienne couleur au nouvelle (pas dec ouleur chang)
	}
}

void RubixCubeRandom(int fois=150){				//fais une srie de mouvement afin que le cube soit mlang
	int t;
	for(int f=0;f<fois;f++){
		animencour = false;
		t = random(0,1);						//valeur au hazard entre 0 et 1 (inclus)
		if(t==1){
			mouv_rx = random(-1,1);
			mouv_ry = 0;
		}else{
			mouv_rx = 0;
			mouv_ry = random(-1,1);
		}
		levelselect = random(0, Cmax);			//valeur au hazard entre 0 et Cmax (inclus) => Cmax=dimensions du cube -1 (numro maximum d'un cube pour chaque dimension)
		copyallCclrinold();
		for( int i = 0; i<dimrubixcubes; i++ )
			for( int j = 0; j<dimrubixcubes; j++ )
				for(int k = 0; k<dimrubixcubes; k++ )
					calculCclr(i,j,k);			//calcule les nouvelles couleurs pour le cube selectionn en fonction des rotations dfinies
	}
	mouv_rx = 0;								//remet les rotaion et le niveau de selection  0
	mouv_ry = 0;
	levelselect = 0;
}

void glCrotate(int i, int j, int k){			//fait une rotation suivant un axe dfini et pendant "timerota" milliseconde
	if(animencour && (
		levelselect==0 ||
		(mouv_rx!=0 && levelselect==i+1) ||
		(mouv_ry!=0 && levelselect==j+1) ||
		(mouv_rz!=0 && levelselect==k+1)
		)){
		glRotated(90*rtactu/timerota, mouv_rx, mouv_ry, mouv_rz);
	}
}

bool isFCselected(int i, int j, int k){ //vrifie si le cube ijk  une face qui est selectionn
	if(mode==2 && hasFCselect && k==dimrubixcubes-1 && FCselect[0]==i && FCselect[1]==j)
		return true;
	return false;
}


void setFCselect(int i, int j){							//selection de la face i,j
	if(hasFCselect && FCselect[0]==i && FCselect[1]==j){//si la face selectionn est la mme que prcedement,
		hasFCselect = false;							//alors on dselectionne la face
	}else{
		hasFCselect = true;								//sinon activation de la selection et
		FCselect[0] = i;								//coordonn de la selection
		FCselect[1] = j;
	}
}

void RubixCubeInitCompteur () {						//initialise le compteur pour vrifier si le cube est complet (fini)
	for(int i=0;i<6;i++){
		RCclrCompteur[i] = RCclrFace[i] = 0;
	}
}

void RubixCubeCompteComplete(int i, int j, int k){	//regarde les faces du cube ijk et pour chaque face incrmente le compteur si c'est la mme couleur que prcdentes
	int coord[3] = {i,j,k};
	int face[3] = {0,2,4};
	int f;
	for(int n=0;n<3;n++){
		if(coord[n]==0 || coord[n]==Cmax){
			f = face[n]+ (coord[n]/Cmax);
			if(RCclrFace[f] == Cclr[f]){
				RCclrCompteur[f]++;
			}else{
				RCclrFace[f] = Cclr[f];
				RCclrCompteur[f]=1;					//sinon remet le compteur  1
			}
		}
	}
}

void RubixCubeComplete(){		//vrifie si le cube est complet (fini)
	int c = 0;
	for(int i=0;i<6;i++){
		if(RCclrCompteur[i]>= dimrubixcubes*dimrubixcubes) c++;	//si toutes les face des cubes ont des couleurs correspondantes
	}
	if(c==6) mode = 3;	//si toutes les faces ont des couleurs correspondantes, le cube est complet donc on passe en mode fin de partie
}

void RubixCube () {
	float arretlength = 2.0f;
	
	if(animencour) rtactu =  clock() - rtimestart;	//dfinition du temps actuelle de la rotation si une animation est en cour
	if(rtactu >= timerota){							//si le temps actuelle de l'animation est suprieur  celui du temps de rotation
		animencour = false;							//arret de l'animation
		CclrReplace = true;							//repositionnage des couleurs
	}

	RubixCubeInitCompteur();

	glLoadIdentity();								//chargement de la matrice identit
	glTranslatef(0.0f,0.0f,-dimrubixcubes*4.5f);	//translate le rubicube pour pouvoir le voir => centre de la rotation et du rubicube
	glRotatef(45,1.0f,1.0f,0.0f);					//rotation

	GLfloat cale = (GLfloat)dimrubixcubes/2 - 0.5f;	//constante qui permet de calcul la position du cube

	for( int i = 0; i<dimrubixcubes; i++ ){
		for( int j = 0; j<dimrubixcubes; j++ ){
			for(int k = 0; k<dimrubixcubes; k++ ){
				glPushMatrix();						//met la matrice active dans le stack
				moovingview();
				glCrotate(i,j,k);					//rotation des cubes si il y a une animation en cour
				glTranslatef(						//translation du cube  sa place
					((GLfloat)i - cale) * arretlength,
					((GLfloat)j - cale) * arretlength,
					((GLfloat)k - cale) * arretlength
				);
				calculCclr(i,j,k);					//calcul les couleur du cube
				cube(isFCselected(i,j,k));			//trace le cube
				glPopMatrix();						//enlve la matrice du stack et reprend la matrice prcdente
				if(mode==2)RubixCubeCompteComplete(i,j,k);		//regarde la couleur du/des faces visible(s) pour voir si le cube est complt
			}
		}
	}
	if(CclrReplace){								//si il y a eut un repositionnage des couleurs
		mouv_rx = mouv_ry = mouv_rz = 0;			//supprtion des rotaion
		CclrReplace=false;							//ne plus replacer les couleurs
	}
	if(mode==2)RubixCubeComplete();							//regarde si le cube est complt en fonction des couleur des face visibles
}

void newaction(int x, int y){				//enregistre une action suivant un angle de rotation
	if(animencour == true && mustfinishmouv){		//si une animation est en cour et si on doit en finr une quand une est en cour
		return;										//on annule l'action
	}
	if(hasFCselect){								//si une face est selectionnn
		if(x!=0){									//si c'est une rotaion en x
			levelselect = FCselect[0]+1;			//le niveau de la rotation sera la coordonn i+1 du cube selectionn
		}else if(y!=0){								//si c'est une rotaion en y
			levelselect = FCselect[1]+1;			//le niveau de la rotation sera la coordonn j+1 du cube selectionn
		}else{
			levelselect=0;
		}
	}else{
		levelselect = 0;							//sinon ce sera tout les cubes qui tourneront
	}
	copyallCclrinold();
	hasFCselect=false;								//on dselectionne la face
	if(x!=0){
		mouv_rx=x;									//on ajoute les rotations
	}else if(y!=0){
		mouv_ry+=y;
	}
	if(mouv_rx!=0 || mouv_ry!=0){					//si il y a une rotation
		animencour = true;							//on lance l'animation
		rtimestart = clock();						//on initialise le compteur de dbut d'animation;
	}
}

void startgame(int dim){
	dimrubixcubes = dim;				//redfinition des variable en fonction du mode jeu
	Cmax = dimrubixcubes-1;
	view_x = view_y = 0;				//annule la rotation de la vue
	srand( (unsigned)time( NULL ) );	//initialise le gnrateur de nombre au hazard
	hasFCselect=false;					//efface la selection
	initallCclr();						//on initialise les couleurs du cube
	RubixCubeRandom();					//on mlange le cube
	timegame = clock();					//dmarrage du compteur
	mode = 2;							//commenc  jouer
}

void rubicubemouvview(){	//incrmente les variable qui serve  faire tourner le cube
	view_x+=0.05f;
	view_y+=0.05f;
}

void rubicuberandomaction(){	//effectue une action au hazard
	if(timer%(timerota*2) < timerota/2 && animencour==false){
		hasFCselect=true;
		FCselect[0] = random(0,Cmax);
		FCselect[1] = random(0,Cmax);
		if(random(0,1)==0){
			newaction(random(-1,1),0);
		}else{
			newaction(0,random(-1,1));
		}
	}
}

#include "keymanage.h"
//#include "sendscore.h"

int DrawGLScene(GLvoid)									//trace la scene opengl
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// supprime les buffer de profondeur et de couleur
	timer = clock();									//assigne le temps actuelle  une variable pour une plus grande rapidit
	drawXoraX();										//affiche les info sur moi
	global_manager();									//regarde si il y a eu une interractaction
	switch (mode) {
	case 2:			//mode jeu
		timerota = 300;									//temps d'un rotation mit  400ms
		drawtimegame();									//affiche le temps de jeu
		cube_manager();									//regarde si il y a eu une interractaction
		RubixCube();
		break;
	case 0: //mode menu
		timerota = 1000;								//temps d'une rotation mit  1s
		rubicuberandomaction();							//effectue une rotaion au hazard
		rubicubemouvview();								//fait tourner la vue
		RubixCube();
		menu_manager();									//regarde si il y a eu une interractaction
		drawinfo();										//affiche le menu
		drawtitle();									//affiche le titre
		break;
	case 3: //mode fin de partie
		rubicubemouvview();
		RubixCube();
		drawfinishtime();
		break;
	}
	drawfps();
	glFlush();

	return true;
}

GLvoid ReSizeGLScene(GLsizei width, GLsizei height)		// Resize And Initialize The GL Window
{
	if (height==0)										// Prevent A Divide By Zero By
	{
		height=1;										// Making Height Equal One
	}

	glViewport(0,0,width,height);						// Reset The Current Viewport

	glMatrixMode(GL_PROJECTION);						// on selectionne la matrice de projection
	glLoadIdentity();									// on charge la matrice identit

	// on dfinie l'angle de vue de la camera, le ratio de l'cran, la profondeur la plus proche et la plus loin visible 
	gluPerspective(45.0f,(GLfloat)width/(GLfloat)height,0.1f,200.0f);

	glMatrixMode(GL_MODELVIEW);							// on selectionne la matrice de perspective
	glLoadIdentity();									// on charge la matrice identit
}

int InitGL(GLvoid)										// on initialise openGL
{
	glShadeModel(GL_SMOOTH);							// Enable Smooth Shading
	glClearColor(0.0f, 0.0f, 0.0f, 0.5f);				// fonds noir
	glClearDepth(1.0f);									// Depth Buffer Setup
	glEnable(GL_DEPTH_TEST);							// Enables Depth Testing
	glDepthFunc(GL_LEQUAL);								// The Type Of Depth Testing To Do
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);	// Really Nice Perspective Calculations
	glLineWidth( 3.0 );
	initfond();
	
	initallCclr();										//on initialise les couleurs du cube
	RubixCubeRandom();									//on mlange le cube

	return true;
}

GLvoid KillGLWindow(GLvoid)								// Properly Kill The Window
{
	if (fullscreen)										// Are We In Fullscreen Mode?
	{
		ChangeDisplaySettings(NULL,0);					// If So Switch Back To The Desktop
		ShowCursor(true);								// Show Mouse Pointer
	}

	if (hRC)											// Do We Have A Rendering Context?
	{
		if (!wglMakeCurrent(NULL,NULL))					// Are We Able To Release The DC And RC Contexts?
		{
			MessageBox(NULL,"Release Of DC And RC Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}

		if (!wglDeleteContext(hRC))						// Are We Able To Delete The RC?
		{
			MessageBox(NULL,"Release Rendering Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}
		hRC=NULL;										// Set RC To NULL
	}

	if (hDC && !ReleaseDC(hWnd,hDC))					// Are We Able To Release The DC
	{
		MessageBox(NULL,"Release Device Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hDC=NULL;										// Set DC To NULL
	}

	if (hWnd && !DestroyWindow(hWnd))					// Are We Able To Destroy The Window?
	{
		MessageBox(NULL,"Could Not Release hWnd.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hWnd=NULL;										// Set hWnd To NULL
	}

	if (!UnregisterClass("OpenGL",hInstance))			// Are We Able To Unregister Class
	{
		MessageBox(NULL,"Could Not Unregister Class.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hInstance=NULL;									// Set hInstance To NULL
	}
}

/*	This Code Creates Our OpenGL Window.  Parameters Are:					*
 *	title			- Title To Appear At The Top Of The Window				*
 *	width			- Width Of The GL Window Or Fullscreen Mode				*
 *	height			- Height Of The GL Window Or Fullscreen Mode			*
 *	bits			- Number Of Bits To Use For Color (8/16/24/32)			*
 *	fullscreenflag	- Use Fullscreen Mode (true) Or Windowed Mode (FALSE)	*/
 
BOOL CreateGLWindow(char* title, int width, int height, int bits, bool fullscreenflag)
{
	GLuint		PixelFormat;			// Holds The Results After Searching For A Match
	WNDCLASS	wc;						// Windows Class Structure
	DWORD		dwExStyle;				// Window Extended Style
	DWORD		dwStyle;				// Window Style
	RECT		WindowRect;				// Grabs Rectangle Upper Left / Lower Right Values
	WindowRect.left=(long)0;			// Set Left Value To 0
	WindowRect.right=(long)width;		// Set Right Value To Requested Width
	WindowRect.top=(long)0;				// Set Top Value To 0
	WindowRect.bottom=(long)height;		// Set Bottom Value To Requested Height

	fullscreen=fullscreenflag;			// Set The Global Fullscreen Flag

	hInstance			= GetModuleHandle(NULL);				// Grab An Instance For Our Window
	wc.style			= CS_HREDRAW | CS_VREDRAW | CS_OWNDC;	// Redraw On Size, And Own DC For Window.
	wc.lpfnWndProc		= (WNDPROC) WndProc;					// WndProc Handles Messages
	wc.cbClsExtra		= 0;									// No Extra Window Data
	wc.cbWndExtra		= 0;									// No Extra Window Data
	wc.hInstance		= hInstance;							// Set The Instance
	wc.hIcon			= LoadIcon(NULL, IDI_WINLOGO);			// Load The Default Icon
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);			// Load The Arrow Pointer
	wc.hbrBackground	= NULL;									// No Background Required For GL
	wc.lpszMenuName		= NULL;									// We Don't Want A Menu
	wc.lpszClassName	= "OpenGL";								// Set The Class Name

	if (!RegisterClass(&wc))									// Attempt To Register The Window Class
	{
		MessageBox(NULL,"Failed To Register The Window Class.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return false;											// Return FALSE
	}
	
	if (fullscreen)												// Attempt Fullscreen Mode?
	{
		DEVMODE dmScreenSettings;								// Device Mode
		memset(&dmScreenSettings,0,sizeof(dmScreenSettings));	// Makes Sure Memory's Cleared
		dmScreenSettings.dmSize=sizeof(dmScreenSettings);		// Size Of The Devmode Structure
		dmScreenSettings.dmPelsWidth	= width;				// Selected Screen Width
		dmScreenSettings.dmPelsHeight	= height;				// Selected Screen Height
		dmScreenSettings.dmBitsPerPel	= bits;					// Selected Bits Per Pixel
		dmScreenSettings.dmFields=DM_BITSPERPEL|DM_PELSWIDTH|DM_PELSHEIGHT;

		// Try To Set Selected Mode And Get Results.  NOTE: CDS_FULLSCREEN Gets Rid Of Start Bar.
		if (ChangeDisplaySettings(&dmScreenSettings,CDS_FULLSCREEN)!=DISP_CHANGE_SUCCESSFUL)
		{
			// If The Mode Fails, Offer Two Options.  Quit Or Use Windowed Mode.
			if (MessageBox(NULL,"Le mode plein cran n'est pas support.\r\nVoulez-vous lancez le programme en mode fentre?","RubiXCube by XoraX",MB_YESNO|MB_ICONEXCLAMATION)==IDYES)
			{
				fullscreen=false;		// Windowed Mode Selected.  Fullscreen = FALSE
			}
			else
			{
				// Pop Up A Message Box Letting User Know The Program Is Closing.
				MessageBox(NULL,"Le programme va maintenant tre ferm.","ERROR",MB_OK|MB_ICONSTOP);
				return false;									// Return FALSE
			}
		}
	}

	if (fullscreen)												// Are We Still In Fullscreen Mode?
	{
		dwExStyle=WS_EX_APPWINDOW;								// Window Extended Style
		dwStyle=WS_POPUP;										// Windows Style
		ShowCursor(false);										// Hide Mouse Pointer
	}
	else
	{
		dwExStyle=WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;			// Window Extended Style
		dwStyle=WS_OVERLAPPEDWINDOW;							// Windows Style
	}

	AdjustWindowRectEx(&WindowRect, dwStyle, false, dwExStyle);		// Adjust Window To True Requested Size

	// Create The Window
	if (!(hWnd=CreateWindowEx(	dwExStyle,							// Extended Style For The Window
								"OpenGL",							// Class Name
								title,								// Window Title
								dwStyle |							// Defined Window Style
								WS_CLIPSIBLINGS |					// Required Window Style
								WS_CLIPCHILDREN,					// Required Window Style
								0, 0,								// Window Position
								WindowRect.right-WindowRect.left,	// Calculate Window Width
								WindowRect.bottom-WindowRect.top,	// Calculate Window Height
								NULL,								// No Parent Window
								NULL,								// No Menu
								hInstance,							// Instance
								NULL)))								// Dont Pass Anything To WM_CREATE
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Window Creation Error.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return false;								// Return FALSE
	}

	static	PIXELFORMATDESCRIPTOR pfd=				// pfd Tells Windows How We Want Things To Be
	{
		sizeof(PIXELFORMATDESCRIPTOR),				// Size Of This Pixel Format Descriptor
		1,											// Version Number
		PFD_DRAW_TO_WINDOW |						// Format Must Support Window
		PFD_SUPPORT_OPENGL |						// Format Must Support OpenGL
		PFD_DOUBLEBUFFER,							// Must Support Double Buffering
		PFD_TYPE_RGBA,								// Request An RGBA Format
		bits,										// Select Our Color Depth
		0, 0, 0, 0, 0, 0,							// Color Bits Ignored
		0,											// No Alpha Buffer
		0,											// Shift Bit Ignored
		0,											// No Accumulation Buffer
		0, 0, 0, 0,									// Accumulation Bits Ignored
		16,											// 16Bit Z-Buffer (Depth Buffer)  
		0,											// No Stencil Buffer
		0,											// No Auxiliary Buffer
		PFD_MAIN_PLANE,								// Main Drawing Layer
		0,											// Reserved
		0, 0, 0										// Layer Masks Ignored
	};
	
	if (!(hDC=GetDC(hWnd)))							// Did We Get A Device Context?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Create A GL Device Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return false;								// Return FALSE
	}

	if (!(PixelFormat=ChoosePixelFormat(hDC,&pfd)))	// Did Windows Find A Matching Pixel Format?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Find A Suitable PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return false;								// Return FALSE
	}

	if(!SetPixelFormat(hDC,PixelFormat,&pfd))		// Are We Able To Set The Pixel Format?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Set The PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return false;								// Return FALSE
	}

	if (!(hRC=wglCreateContext(hDC)))				// Are We Able To Get A Rendering Context?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Create A GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return false;								// Return FALSE
	}

	if(!wglMakeCurrent(hDC,hRC))					// Try To Activate The Rendering Context
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Activate The GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return false;								// Return FALSE
	}

	ShowWindow(hWnd,SW_SHOW);						// Show The Window
	SetForegroundWindow(hWnd);						// Slightly Higher Priority
	SetFocus(hWnd);									// Sets Keyboard Focus To The Window
	ReSizeGLScene(width, height);					// Set Up Our Perspective GL Screen

	if (!InitGL())									// Initialize Our Newly Created GL Window
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Initialization Failed.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return false;								// Return FALSE
	}

	return true;									// Success
}

LRESULT CALLBACK WndProc(	HWND	hWnd,			// Handle For This Window
							UINT	uMsg,			// Message For This Window
							WPARAM	wParam,			// Additional Message Information
							LPARAM	lParam)			// Additional Message Information
{
	switch (uMsg)
	{
		case WM_ACTIVATE:
		{
			if ((LOWORD(wParam) != WA_INACTIVE) && !((BOOL)HIWORD(wParam)))
				active=true;
			else
				active=false;

			return 0;
		}
		case WM_CLOSE:
		{
			PostQuitMessage(0);
			return 0;
		}

		case WM_KEYDOWN:
		{
			keys[wParam] = true;
			return 0;
		}

		case WM_KEYUP:
		{
			keys[wParam] = false;
			return 0;
		}

		case WM_SIZE:
		{
			ReSizeGLScene(LOWORD(lParam),HIWORD(lParam));
			return 0;
		}
	}
	return DefWindowProc(hWnd,uMsg,wParam,lParam);
}

int WINAPI WinMain(	HINSTANCE	hInstance,			// Instance
					HINSTANCE	hPrevInstance,		// Previous Instance
					LPSTR		lpCmdLine,			// Command Line Parameters
					int			nCmdShow)			// Window Show State
{
	MSG		msg;									// Windows Message Structure
	BOOL	done=false;								// Bool Variable To Exit Loop

	// Demande si on veut actiiver le mode plein cran
	if (MessageBox(NULL,"Voulez vous activer le mode plein cran?", "fullscreen?",MB_YESNO|MB_ICONQUESTION)==IDNO)
	{	//si la rponse est non
		fullscreen=false;	//selectionne le mode fntre
	}

	if (!CreateGLWindow("RubiXCube by XoraX",width,height,16,fullscreen)) //si la cration de la fentre choue
	{
		return 0;	//on retourne une fermeture du programme avec une erreur
	}

	srand( (unsigned)time( NULL ) ); //initialise le gnrateur de nombre au hazard

	while(!done)
	{
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))
		{
			if (msg.message==WM_QUIT)
			{
				done=true;
			}
			else
			{
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}
		else
		{
			if ((active && !DrawGLScene()) || keys[VK_ESCAPE])
			{
				ShowCursor( false );
				done=true;
			}
			else
			{
				ShowCursor( true );
				SwapBuffers(hDC);
			}

			if (keys[VK_F1])
			{
				keys[VK_F1]=false;
				KillGLWindow();
				fullscreen=!fullscreen;
				if (!CreateGLWindow("RubiXCube by XoraX",width,height,16,fullscreen))
				{
					return 0;
				}
			}
		}
	}

	KillGLWindow();
	return (msg.wParam);
}
