void coloraffect(int *a, int *b){ //affecte le tableau de couleur (lenght=6) b au tableau a
	for(int i=0; i<6; i++){
		*(a+i) = *(b+i);
	}
}

void copyallCclrinold(){ //copie le tableau actuelle de couleur (allCclr) dans le tableau (alloldCclr)
	for( int i = 0; i<dimrubixcubes; i++ )
		for( int j = 0; j<dimrubixcubes; j++ )
			for(int k = 0; k<dimrubixcubes; k++ )
				coloraffect(alloldCclr[i][j][k],allCclr[i][j][k]);
}

void glColorS (double r, double g, double b){	//envoie une instruction de couleur  openGL avec des couleurs /256
	glColor3d((GLdouble)r/255,(GLdouble)g/255,(GLdouble)b/255);
}

void glclrcube(int c=0){	//envoie une instruction de couleur  openGL suivant la face du cube
	switch(c) {
	case 1: 
		glColorS(36,6,153); //bleu
		break;
	case 2:
		glColorS(255,255,255); //blanc
		break;
	case 3:
		glColorS(225,0,0); //rouge
		break;
	case 4:
		glColorS(255,120,0); //orange
		break;
	case 5:
		glColorS(233,243,10); //jaune
		break;
	case 6:
		glColorS(28,185,0); //vert
		break;
	default:
		glColor3f(0.0f,0.0f,0.0f); //noir
		break;
	};
}

void cube(bool selected = false){	//dssine un cube avec la selection si il y en a une sur ce cube
	float ecar = 0.05f;
	GLfloat ea = 1.0f - ecar;
	GLfloat eb = -1.0f + ecar;
	GLfloat a = 1.0f;
	GLfloat b = -1.0f;

	glBegin(GL_QUADS); //construction des faces du cube
		glclrcube(Cclr[3]);	//carre haut
		glVertex3f( ea, a, eb);
		glVertex3f( eb, a, eb);
		glVertex3f( eb, a, ea);
		glVertex3f( ea, a, ea);
		glclrcube(Cclr[2]);	//carre bas
		glVertex3f( ea, b, ea);
		glVertex3f( eb, b, ea);
		glVertex3f( eb, b, eb);
		glVertex3f( ea, b, eb);
		glclrcube(Cclr[5]);	//carre face 
		glVertex3f( ea, ea, a);
		glVertex3f( eb, ea, a);
		glVertex3f( eb, eb, a);
		glVertex3f( ea, eb, a);
		glclrcube(Cclr[4]);	//carre fond
		glVertex3f( ea, eb, b);
		glVertex3f( eb, eb, b);
		glVertex3f( eb, ea, b);
		glVertex3f( ea, ea, b);
		glclrcube(Cclr[0]);	//carre gauche
		glVertex3f( b, ea, ea);
		glVertex3f( b, ea, eb);
		glVertex3f( b, eb, eb);
		glVertex3f( b, eb, ea);
		glclrcube(Cclr[1]);	//carre droite
		glVertex3f( a, ea, eb);
		glVertex3f( a, ea, ea);
		glVertex3f( a, eb, ea);
		glVertex3f( a, eb, eb);
	glEnd();
	glBegin(GL_QUADS); //ajout des arrtes coups
		glclrcube(0);
		glVertex3f( ea, ea, a); //aret haut face
		glVertex3f( eb, ea, a);
		glVertex3f( eb, a, ea);
		glVertex3f( ea, a, ea);

		glVertex3f( ea, ea, b); //aret haut fond
		glVertex3f( eb, ea, b);
		glVertex3f( eb, a, eb);
		glVertex3f( ea, a, eb);

		glVertex3f( ea, eb, a); //aret bas face
		glVertex3f( eb, eb, a);
		glVertex3f( eb, b, ea);
		glVertex3f( ea, b, ea);

		glVertex3f( ea, eb, b); //aret bas fond
		glVertex3f( eb, eb, b);
		glVertex3f( eb, b, eb);
		glVertex3f( ea, b, eb);

		glVertex3f( ea, ea, a); //aret droite face
		glVertex3f( ea, eb, a);
		glVertex3f( a, eb, ea);
		glVertex3f( a, ea, ea);

		glVertex3f( ea, ea, b); //aret droite fond
		glVertex3f( ea, eb, b);
		glVertex3f( a, eb, eb);
		glVertex3f( a, ea, eb);

		glVertex3f( eb, ea, a); //aret gauche face
		glVertex3f( eb, eb, a);
		glVertex3f( b, eb, ea);
		glVertex3f( b, ea, ea);
		
		glVertex3f( eb, ea, b); //aret gauche fond
		glVertex3f( eb, eb, b);
		glVertex3f( b, eb, eb);
		glVertex3f( b, ea, eb);

		glVertex3f( ea, a, ea); //aret haut droite
		glVertex3f( ea, a, eb);
		glVertex3f( a, ea, eb);
		glVertex3f( a, ea, ea);

		glVertex3f( ea, b, ea); //aret bas droite
		glVertex3f( ea, b, eb);
		glVertex3f( a, eb, eb);
		glVertex3f( a, eb, ea);

		glVertex3f( eb, a, ea); //aret haut gauche
		glVertex3f( eb, a, eb);
		glVertex3f( b, ea, eb);
		glVertex3f( b, ea, ea);

		glVertex3f( eb, b, ea); //aret haut gauche
		glVertex3f( eb, b, eb);
		glVertex3f( b, eb, eb);
		glVertex3f( b, eb, ea);
	glEnd();

	glBegin(GL_TRIANGLES); //construction des coins coup
		glVertex3f( ea, ea, a); //coin haut droit face
		glVertex3f( ea, a, ea);
		glVertex3f( a, ea, ea);

		glVertex3f( ea, eb, a); //coin bas droit face
		glVertex3f( ea, b, ea);
		glVertex3f( a, eb, ea);

		glVertex3f( eb, eb, a); //coin bas gauche face
		glVertex3f( eb, b, ea);
		glVertex3f( b, eb, ea);

		glVertex3f( eb, ea, a); //coin haut gauche face
		glVertex3f( eb, a, ea);
		glVertex3f( b, ea, ea);

		glVertex3f( ea, ea, b); //coin haut droit fond
		glVertex3f( ea, a, eb);
		glVertex3f( a, ea, eb);

		glVertex3f( ea, eb, b); //coin bas droit fond
		glVertex3f( ea, b, eb);
		glVertex3f( a, eb, eb);

		glVertex3f( eb, eb, b); //coin bas gauche fond
		glVertex3f( eb, b, eb);
		glVertex3f( b, eb, eb);

		glVertex3f( eb, ea, b); //coin haut gauche fond
		glVertex3f( eb, a, eb);
		glVertex3f( b, ea, eb);
	glEnd();

	if(selected){
		double t = (double) timer/100;
		glColor3f((float)cos(t),(float)sin(t),(float)tan(t));
		glBegin(GL_LINE_LOOP);
		glVertex3f( a, a, 1.1f);
		glVertex3f( b, a, 1.1f);
		glVertex3f( b, b, 1.1f);
		glVertex3f( a, b, 1.1f);
		glEnd();
	}
}

void initallCclr () {							//initialise les couleurs de bases des face de chaque cube
	for( int i = 0; i<dimrubixcubes; i++ ){
		for( int j = 0; j<dimrubixcubes; j++ ){
			for(int k = 0; k<dimrubixcubes; k++ ){
				if(i==0) {
					allCclr[i][j][k][0] = 5;
					alloldCclr[i][j][k][0] = 5;
				}
				if(i==dimrubixcubes-1) {
					allCclr[i][j][k][1] = 6;
					alloldCclr[i][j][k][1] = 6;
				}
				if(j==0) {
					allCclr[i][j][k][2] = 2;
					alloldCclr[i][j][k][2] = 2;
				}
				if(j==dimrubixcubes-1) {
					allCclr[i][j][k][3] = 1;
					alloldCclr[i][j][k][3] = 1;
				}
				if(k==0) {
					allCclr[i][j][k][4] = 4;
					alloldCclr[i][j][k][4] = 4;
				}
				if(k==dimrubixcubes-1) {
					allCclr[i][j][k][5] = 3;
					alloldCclr[i][j][k][5] = 3;
				}
			}
		}
	}
}