void gl_print( GLuint &listfont, GLfloat red, GLfloat green, GLfloat blue, GLint x, GLint y, const char *format, ... )
{	//crit du texte format selon une police listfont, une couleur et sur une position x,y
	va_list argp;
    char text[256];

    va_start( argp, format );
    vsprintf( text, format, argp );
    va_end( argp );

    glMatrixMode( GL_PROJECTION );
    glPushMatrix();

        glLoadIdentity();
        gluOrtho2D( 0.0, (GLdouble) width,
                    0.0, (GLdouble) height );

        glMatrixMode( GL_MODELVIEW );
		glPushMatrix();
		glLoadIdentity();
		//glTranslatef(0.0f,0.0f,-0.5f);
        glColor3f( red, green, blue);
        glRasterPos2i( x, y );
        glPushAttrib(GL_LIST_BIT);
		glListBase( listfont );
        glCallLists( strlen( text ), GL_UNSIGNED_BYTE, text );
		glPopAttrib();
		glPopMatrix();

    glMatrixMode( GL_PROJECTION );
    glPopMatrix();
	glMatrixMode( GL_MODELVIEW );

}

void genlistfont( GLuint &listname, HFONT &font){ //gnre une liste de police
	HFONT oldfont;
	oldfont = (HFONT)SelectObject(hDC, font);
	wglUseFontBitmaps(hDC, 0, 255, listname);
	SelectObject(hDC, oldfont);
	DeleteObject(font);
}

void initfond(){ //initialize les polices utiliss
	HFONT font;
	

	wintitle = glGenLists( 255 );
	font = CreateFont(	100,							// taille de la police
						0,								// cartement
						0,								// agle
						0,								// orientation de l'angle
						FW_BOLD,						// paisseur
						false,							// italic
						false,							// soulign
						false,							// barr
						ANSI_CHARSET,					// Character Set Identifier
						OUT_TT_PRECIS,					// precision de sortie
						CLIP_DEFAULT_PRECIS,			// precision de clipping?
						ANTIALIASED_QUALITY,			// qualit de rendu
						FF_DONTCARE|DEFAULT_PITCH,
						"Comic sans ms");				// nom de la police
	genlistfont(wintitle, font);

	winmessage = glGenLists( 255 );
	font = CreateFont(	20,
						0,
						0,
						0,
						FW_MEDIUM,
						true,
						false,
						false,
						ANSI_CHARSET,
						OUT_TT_PRECIS,
						CLIP_DEFAULT_PRECIS,
						ANTIALIASED_QUALITY,
						FF_DONTCARE|DEFAULT_PITCH,
						"Courier New");
	genlistfont(winmessage, font);

	bigtitle = glGenLists( 255 );
	font = CreateFont(	50,
						0,
						0,
						0,
						FW_BOLD,
						false,
						false,
						false,
						ANSI_CHARSET,
						OUT_TT_PRECIS,
						CLIP_DEFAULT_PRECIS,
						ANTIALIASED_QUALITY,
						FF_DONTCARE|DEFAULT_PITCH,
						"Courier New");
	genlistfont(bigtitle, font);

	fonttime = glGenLists( 255 );
	font = CreateFont(	25,
						0,
						0,
						0,
						FW_BOLD,
						false,
						false,
						false,
						ANSI_CHARSET,
						OUT_TT_PRECIS,
						CLIP_DEFAULT_PRECIS,
						ANTIALIASED_QUALITY,
						FF_DONTCARE|DEFAULT_PITCH,
						"Courier New");
	genlistfont(fonttime, font);

	fontfps = glGenLists( 255 );
	font = CreateFont(	-12,
						0,
						0,
						0,
						FW_MEDIUM,
						false,
						false,
						false,
						ANSI_CHARSET,
						OUT_TT_PRECIS,
						CLIP_DEFAULT_PRECIS,
						ANTIALIASED_QUALITY,
						FF_DONTCARE|DEFAULT_PITCH,
						"Times New Roman");
	genlistfont(fontfps, font);
}
